# This file is a template, and might need editing before it works on your project.
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Nodejs.gitlab-ci.yml

# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/node/tags/
stages:
  - ".pre"
  - "build"
  - "deploy-staging"
  - "test"
  - "deploy"


build_website:
    image: node:latest
    stage: build
    script:
        - yarn install
        - yarn build

    artifacts:
      paths:
        - "build"
      untracked: false
      when: on_success
      expire_in: 30 days

website_test:
  image: node:16-alpine
  stage: test
  script: 
    - test -f build/index.html
    - yarn global add serve
    - apk add curl
    - serve -s build
    - sleep 10
    - curl "http://localhost:3000" | grep "React App"

unit_test:
  image : node:latest
  stage: test
  script:
    - yarn install
    - yarn test


deploy_to_aws:
  stage: deploy
  rules:
    - if: $CI_COMMIT_REF_NAME == 'feature'
  image: 
    name: amazon/aws-cli
    entrypoint: [""]
  script: 
    - echo "running in the feature branch"
    - aws --version
    - echo "Hello S3" > s3_file.txt
    - aws s3 cp s3_file.txt s3://gitlab-bucket-sk/s3_file.txt


# Pick zero or more services to be used on all builds.
# Only needed when using a docker container to run your tests in.
# Check out: https://docs.gitlab.com/ee/ci/services/index.html
services:
  - mysql:latest
  - redis:latest
  - postgres:latest

# This folder is cached between builds
# https://docs.gitlab.com/ee/ci/yaml/index.html#cache
cache:
  paths:
    - node_modules/